local firsttab = true
local result = false
local version = "4.2.2"
local autoban = 100

function antispamwr_postFilter(...)
	firsttab = true
end

function antispamwr_SlashHandler(msg, box)
	msg = string.lower(msg)

	if( msg == "purge all" ) then
		antispamwr_magics["phrases"] = {}
		antispamwr_magics["nicknames"] = {}
		antispamwr_magics["wphrases"] = {}
		print ("Все словари очищены");
	elseif( msg == "purge black" ) then
		antispamwr_magics["phrases"] = {}
		antispamwr_magics["nicknames"] = {}
		print ("Очищены словари черного списка");
	elseif( msg == "purge white" ) then
		antispamwr_magics["wphrases"] = {}
		print ("Очищены словари белого списка");
	elseif( msg == "stat" ) then
		print ("Жалоб в эту сессию: "..antispamwr_magics["statistic"]["session"]);
		print ("Жалоб всего: "..antispamwr_magics["statistic"]["total"]);
	else
		print ("Антиспам аддон от WowRaider.Ru версия "..version)
		print ("Список команд:")
		print (" /aswr help - показывает подсказку")
		print (" /aswr stat - показывает статистику")
		print (" /aswr purge all - очищает все словари, обнуляет обучение")
		print (" /aswr purge black - очищает словари заблокированных сообщений и имен")
		print (" /aswr purge white - очищает словари сообщений белого списка")
	end

end

function antispamwr_Filter(...)
	local self, event, msg, user,  language, channelString, target, flags, unknown1, channelNumber, channelName, unknown2, msgcounter, guid= ...
	result = false
	
	if( not(firsttab) ) then
--		print("PostFiltered for "..self["name"])
		return result
	end
--	print("Filtered for "..self["name"])
	firsttab = false
	
	local lmsg = string.lower(msg)

	local weight = 0;
	for word, val in pairs(antispamwr_magics["templates"]) do
		if( weight < autoban ) then
			word = string.lower(word)
			if( string.find(lmsg, word, 1, true)) then
				weight = weight + val
			end
		end
	end

	if( weight > 0 and not(antispamwr_magics["wphrases"][lmsg]) ) then 
		if( weight >= autoban or antispamwr_magics["phrases"][lmsg] or antispamwr_magics["phrases"][user] ) then
			result = antispamwr_Report(msgcounter, user, lmsg)
		else
			result = true;
			StaticPopupDialogs["ANTISPAMWR_CONFIRM"] = {
				text = "Хотите ли вы пожаловаться на сообщение: \n"..msg.."?",
				button1 = "Да",
				button2 = "Нет",
				OnAccept = function(self, unk1, reason)
					antispamwr_magics["manually"][lmsg] = 1;
					result = antispamwr_Report(msgcounter, user, lmsg)
				end,
				OnCancel = function(self, unk1, reason)
					if( reason == 'clicked') then
						antispamwr_magics["wphrases"][lmsg] = 1;
					end
				end,
				timeout = 0,
				whileDead = true,
				hideOnEscape = true
				}
			StaticPopup_Show("ANTISPAMWR_CONFIRM")
		end
	end
	return result
end

function antispamwr_Report(msgcounter, user, lmsg)
	ComplainChat(msgcounter)
	antispamwr_magics["nicknames"][user] = 1;
	antispamwr_magics["phrases"][lmsg] = 1;
	antispamwr_magics["statistic"]["session"] = antispamwr_magics["statistic"]["session"]+1;
	antispamwr_magics["statistic"]["total"] = antispamwr_magics["statistic"]["total"]+1;
	return true
end

function antispamwr_Init()
	if( not antispamwr_magics) then
		antispamwr_magics = {
			["templates"] = {},
			["nicknames"] = {},
			["phrases"] = {}
			};
	end
	antispamwr_magics["templates"] = {
			["trоllmоnеy"] = 100,
			["wowmoney"] = 100,
			["wowmoney"] = 100,
			["wowмоneу"] = 100,
			["a.sworm"] = 100,
			["tpalala_"] = 100,
			["вовголд"] = 100,
			["wow_gold"] = 100,
			["тrоllмоnеy"] = 100,
			["wowgoldsale"] = 100,
			["gold_money_now"] = 100,
			["souliceman"] = 100,
			["тrоllмоnеy"] = 100,
			["gnomoptovik"] = 100,
			["wow-g-online"] = 100,
			["З0Л0ТО"] = 100,
			["INGMONEY"] = 100,
			["gamersgold"] = 100,
			["KingPeon"] = 100,

			["тrоllмоnеy"] = 100,
			["mmo-shop"] = 100,
			["ggrpg"] = 100,
			["moneybooker"] = 100,
			["duckgold"] = 100,
			
			["г0"] = 100,
			["р0"] = 100,
			["д0"] = 100,
			["аттестат"] = 100,
			["30л0"] = 100,
			["г0лд"] = 100,
			["gо1d"] = 100,			
			["30ло"] = 100,			
			["м0"] = 100,			
			["неt"] = 100,			
			["kи"] = 100,			
			["balalayka92"] = 100,			
			["rpgbox"] = 100,			
			["wowgoldbest"] = 100,			
			["монетныидвор"] = 100,			
			["wow4real"] = 100,			
			["mmoney"] = 100,			
			["вовсчастье"] = 100,			
			
			["onlinemagazine"] = 100,			
			["блестяшк"] = 100,
			["блестях"] = 100,
			["6лестяшк"] = 100,
			["6лестях"] = 100,
			["лотишко"] = 100,

			["овощевик"] = 100,
			["0вощевик"] = 100,
			["oвощевик"] = 100,
			["ов0щевик"] = 100,
			["овoщевик"] = 100,
			
			["golg_money_now"] = 100,
			["cosmos1140"] = 100,
			["rpg-shop"] = 100,
			["мoнeткu"] = 100,
			["Mywowgold"] = 100,
			["mуwоwgold"] = 100,
			["mуwowgоld"] = 100,
			["rpgdealer"] = 100,
			["trolmoney"] = 100,
			["mуwowgold"] = 100,
			["GGSHOP"] = 100,
			["mywоwgоld"] = 100,
			["zолoт0"] = 100,
			["mywоwgold"] = 100,
			["monetasrazu"] = 100,
			["RPGSHOP"] = 100,
			
			
			["киви"] = 50,
			["qiwi"] = 50,
			["ІCQ"] = 50,
			["ІСQ"] = 50,
			["icq"] = 50,
			["{круг}"] = 50,
			["iсq"] = 50,
			["монеты"] = 50,
			["золот"] = 50,
			}
	if( not antispamwr_magics["wphrases"] ) then
		antispamwr_magics["wphrases"] = {}
	end
	if( not antispamwr_magics["manually"] ) then
		antispamwr_magics["manually"] = {}
	end
-- [18:40:38] [2] [Риалфаст]: zоlот0 oт 21 до 26. Aкаунты с 85 lvl oт 18оо pyблей. Пpокaчкa нa зaказ ІСQ: 55-95-777 Sкуpe: mуwowgоld.ru	
	if( not antispamwr_magics["statistic"] ) then
		antispamwr_magics["statistic"] = {
			["total"] = 0,
			}
	end

	antispamwr_magics["statistic"]["session"] = 0;
	
	SLASH_ASWR1 = '/aswr';
	SlashCmdList["ASWR"] = antispamwr_SlashHandler	

	antispamwr_Frame:RegisterEvent("CHAT_MSG_CHANNEL")
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL",antispamwr_Filter)
	print("Анти-спаммер от WowRaider.Ru. Версия "..version.." Управление /aswr")
end
